Subject: Re: [PATCH v2 6/7] Holly DTS

From: David Gibson <[email-masked]>
Date: Mon, 14 May 2007 10:24:57 +1000

On Sat, May 12, 2007 at 02:02:42PM +0200, Segher Boessenkool wrote:
> >>> What exactly did this ?? syntax imply?  I must have missed that 
> >>> thread.
> >>
> >> A property in a DTS file can use that to say
> >> the property should have a value, but it will
> >> be filled in by the bootwrapper instead (memory
> >> address/size, or network MAC address, for
> >> instance).  Presumably the kernel parser would
> >> complain when it sees the this-is-still-undefined
> >> marker.
> >>
> >> The original proposal specified the length of
> >> the property value IIRC, but that isn't necessary
> >> anymore.
> >
> > Well.. sort of.  The first cut at the idea is that ? would be
> > equivalent to zeroes in terms of dtc output, but would act as internal
> > documentation that that property is supposed to be filled in by the
> > bootloader.
> 
> Yes.
> 
> > Refinements to try to enforce that would be nice:
> 
> Exactly my point.
> 
> > easiest is to
> > replace it with a configurable poison value.  When using asm output,
> > or with a map file, it might be possible to generate out-of-band
> > information which we can use to check that the right things are filled
> > in.
> >
> > It's not a simply a matter of making the kernel parser recognize the
> > uninitialized info, because there's no way to encode that in the dtb
> > itself.
> 
> There can be, with a new DTB version -- perhaps simply
> define proplen == -1 to mean "undefined" or similar.

That doesn't quite do it, because I'd prefer ? to cover cases where
the property's length is known, just not its value.  In particular
that could be useful for device trees where *only* non-moving edits
are required by the bootloader, letting us use the asm output mode as
intended.

-- 
David Gibson			| I'll have my music baroque, and my code
david AT gibson.dropbear.id.au	| minimalist, thank you.  NOT _the_ _other_
				| _way_ _around_!
http://www.ozlabs.org/~dgibson